#property copyright "Copyright (c) 2008, "
#include <stdlib.mqh>

extern int PipsReverse = 3;				//      ,   .
extern double ProfitTarget = 2;
extern bool StopLossIsForced = false;	//  true,   ,  false,  
extern int StopLoss = 30;
extern double Lots = 0.1;
extern double Slippage = 1;

#define Up 1
#define Dn 2
#define Unknown -1

#define Buy 0
#define Sell 1

int BuyMagic = 2300000;
int SellMagic = 2400000;

double spread;


//int CurrDirection = Unknown;
//int PrevDirection = Unknown;

bool NeedToOpenSell = false;
bool NeedToOpenBuy = false;
double SellOpenLevel;
double BuyOpenLevel;

int LastOrderType = Unknown;

int PrevBuys = 0;
int PrevSells = 0;

void init()
{
	spread = Ask - Bid;
	
	BuyMagic = 2300000;
	SellMagic = 2400000;

	BuyMagic += Period();
	SellMagic += Period();
	
	LastOrderType = Unknown;
	
	NeedToOpenSell = false;
	NeedToOpenBuy = false;
	PrevBuys = 0;
	PrevSells = 0;
}

void deinit()
{

}

void start()
{
	if(ProfitSell() >= ProfitTarget)
	{
		CloseAllSell();
	}
	if(ProfitBuy() >= ProfitTarget)
	{
		CloseAllBuy();
	}
	
	if(StopLossIsForced)
	{
		CheckForSL();
	}
		
	int Buys = TotalBuy();
	int Sells = TotalSell();
	
	if(Buys < PrevBuys)			//  -   
	{
		NeedToOpenBuy = false;
		//NeedToOpenSell = false;
	}
	if(Sells < PrevSells)
	{
		//NeedToOpenBuy = false;
		NeedToOpenSell = false;
	}
	
	PrevBuys = Buys;
	PrevSells = Sells;

	if(Buys == 0 && Sells == 0)
	{
		if(LastOrderType != Sell)
		{
			OpenSell();
			LastOrderType = Sell;
			NeedToOpenBuy = false;
			NeedToOpenSell = false;
			BuyOpenLevel = Ask + PipsReverse*Point;
		}
		else if(LastOrderType != Buy)
		{
			OpenBuy();
			LastOrderType = Buy;
			NeedToOpenBuy = false;
			NeedToOpenSell = false;
			SellOpenLevel = Bid - PipsReverse*Point;
		}
	}
	else
	{
		if(Buys != 0 && Sells == 0 /*&& !NeedToOpenSell*/)
		{
			NeedToOpenSell = true;
			
			SellOpenLevel = GetBuyOpenLevel() - spread - PipsReverse*Point;
		}

		if(Sells != 0 && Buys == 0/* && !NeedToOpenBuy*/)
		{
			NeedToOpenBuy = true;
			BuyOpenLevel = GetSellOpenLevel()  + spread + PipsReverse*Point;
		}
	}
	
	if(NeedToOpenSell && Bid <= SellOpenLevel)
	{
		OpenSell();

		NeedToOpenSell = false;
		LastOrderType = Sell;
	}
	if(NeedToOpenBuy && Ask >= BuyOpenLevel)
	{
		OpenBuy();

		NeedToOpenBuy = false;
		LastOrderType = Buy;
	}

}


void OpenBuy()
{
	int i;		
	double BuyOpen;
	double BuyTP = 0;
	double BuySL = 0;
	
	RefreshRates();
	BuyOpen  = Ask;
	//if(TakeProfit != 0)
	//{
	//	BuyTP = BuyOpen + spread + TakeProfit * Point;
	//}
	if(StopLoss != 0 && !StopLossIsForced)
	{
		BuySL = BuyOpen - StopLoss * Point;
	}

	//----------------------------------
	datetime begin = TimeCurrent();
	int ticket = OrderSend(Symbol(), OP_BUY, Lots, BuyOpen, Slippage, BuySL, BuyTP, "", BuyMagic, 0, Blue);
	
	int error;
	if (ticket==-1)
	{
		while(ticket == -1 && TimeCurrent() - begin < 20 && !IsTesting())
		{
			error = GetLastError();
			Print("   BUY. " + ErrorDescription(error));
			Sleep(100);
			Print("");
			RefreshRates();

			BuyOpen  = Ask;
			//if(TakeProfit != 0)
			//{
			//	BuyTP = BuyOpen + spread + TakeProfit * Point;
			//}
			if(StopLoss != 0 && !StopLossIsForced)
			{
				BuySL = BuyOpen - StopLoss * Point;
			}
		    ticket = OrderSend(Symbol(), OP_BUY, Lots, BuyOpen, Slippage, BuySL, BuyTP, "", BuyMagic, 0, Blue);
		}
		if(ticket == -1)
		{
			error = GetLastError();
			Print("   BUY. " + ErrorDescription(error));
		}
	}
	
	if (ticket != -1)
	{
		Print(" BUY  " + Symbol() + " " + Period() + "  " + Lots + "!");
	}
	else
	{
		error = GetLastError();
		Print("   BUY. " + ErrorDescription(error));
	}
	//-------------------------------------------------------------
}

/****************  ********************/

void OpenSell()
{
	int i;
	double SellOpen;
	double SellTP = 0;
	double SellSL = 0;

	RefreshRates();
	
	SellOpen = Bid;
	//if(TakeProfit != 0)
	//{
	//	SellTP = SellOpen - spread - TakeProfit * Point;
	//}
	if(StopLoss != 0 && !StopLossIsForced)
	{
		SellSL = SellOpen + StopLoss * Point;
	}
	
	datetime begin;
   int ticket = OrderSend(Symbol(), OP_SELL, Lots, SellOpen, Slippage, SellSL, SellTP, "", SellMagic, 0, Red);

	int error;
	if (ticket==-1)
	{
		//error=GetLastError();
		//Print("SELL error(",error,"): ",ErrorDescription(error));
		while(ticket == -1 && TimeCurrent() - begin < 20 && !IsTesting())
		{
			error = GetLastError();
			Print("   SELL. " + ErrorDescription(error));
			Sleep(100);
			Print("");
			RefreshRates();

			SellOpen = Bid;
			//if(TakeProfit != 0)
			//{
			//	SellTP = SellOpen - spread - TakeProfit * Point;
			//}
			if(StopLoss != 0 && !StopLossIsForced)
			{
				SellSL = SellOpen + StopLoss * Point;
			}

		    ticket = OrderSend(Symbol(), OP_SELL, Lots, SellOpen, Slippage, SellSL, SellTP, "", SellMagic, 0, Red);
		}
		if(ticket == -1)
		{
			error = GetLastError();
			Print("   SELL. " + ErrorDescription(error));
		}
	}

    if (ticket != -1)
   	{
		Print(" SELL  " + Symbol() + " " + Period() + "  " + Lots + "!");
	}
	else
	{
		error = GetLastError();
		Print("   SELL. " + ErrorDescription(error));
	}
	//----------------------------------------------------------------------
}

int TotalBuy()
{
	int count=0;
	for (int i=0; i<OrdersTotal(); i++)
  	{
  		if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) break;
  		
  		if(OrderSymbol() == Symbol() && OrderMagicNumber() == BuyMagic && OrderType() == OP_BUY) 
  			count++;
  	}
	return (count);
}



int TotalSell()
{
	int count=0;
	for (int i=0; i<OrdersTotal(); i++)
  	{
  		if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) break;
  		if(OrderSymbol() == Symbol() && OrderMagicNumber() == SellMagic && OrderType() == OP_SELL)
  			count++;
  	}
	return (count);
}

double GetSellOpenLevel()
{
	double result = 0;
	for (int i=0; i<OrdersTotal(); i++)
  	{
  		if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) break;
  		if(OrderSymbol() == Symbol() && OrderMagicNumber() == SellMagic && OrderType() == OP_SELL)
  		{
  			result = OrderOpenPrice();
  			break;
  		}
  	}
	return (result);
}

double GetBuyOpenLevel()
{
	double result = 0;
	for (int i=0; i<OrdersTotal(); i++)
  	{
  		if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) break;
  		if(OrderSymbol() == Symbol() && OrderMagicNumber() == BuyMagic && OrderType() == OP_BUY) 
  		{
  			result = OrderOpenPrice();
  			break;
  		}
  	}
	return (result);
}

double ProfitSell()
{
	int i;
	int orders = OrdersTotal();
	double result = 0;
	
	for(i = orders - 1; i >= 0; i--)
	{
		if(!OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
		{
			Print("     [6]. :" + ErrorDescription(GetLastError()));
			continue;
		}
		
		if(OrderSymbol() == Symbol())
		{
			if(OrderType() == OP_SELL && OrderMagicNumber() == SellMagic)
			{
				result += OrderProfit() + OrderSwap();
			}
		}
	}
	
	return (result);
}

double ProfitBuy()
{
	int i;
	int orders = OrdersTotal();
	double result = 0;
	
	for(i = orders - 1; i >= 0; i--)
	{
		if(!OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
		{
			Print("     [6]. :" + ErrorDescription(GetLastError()));
			continue;
		}
		
		if(OrderSymbol() == Symbol())
		{
			if(OrderType() == OP_BUY && OrderMagicNumber() == BuyMagic)
			{
				result += OrderProfit() + OrderSwap();
			}
		}
	}
	
	return (result);
}

void CloseAllSell()
{
	int i;
	int Orders = OrdersTotal();
	bool result;
	datetime begin;
	
	if(Orders > 0)
	{
		for(i = Orders-1; i >= 0; i--)
		{
			if( OrderSelect(i, SELECT_BY_POS, MODE_TRADES) )
			{
				if(OrderSymbol() == Symbol() && OrderType() == OP_SELL && OrderMagicNumber() == SellMagic)
				{
					begin = TimeCurrent();
					result = OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, Yellow);			//    
					while(!result && TimeCurrent() - begin <= 30 && !IsTesting())
					{
						Sleep(100);
						result = OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, Yellow);			//    
					}
					if(!result)
					{
						int error = GetLastError();
						Print("   SELL #" + OrderTicket() + " " + ErrorDescription(error));
					}
				}
			}
			else
			{
				Print("    :" + ErrorDescription(error));
			}
		}
	}
}

void CloseAllBuy()
{
	int i;
	int Orders = OrdersTotal();
	bool result;
	datetime begin;
	
	if(Orders > 0)
	{
		for(i = Orders-1; i >= 0; i--)
		{
			if( OrderSelect(i, SELECT_BY_POS, MODE_TRADES) )
			{
				if(OrderSymbol() == Symbol() && OrderType() == OP_BUY && OrderMagicNumber() == BuyMagic)
				{
					begin = TimeCurrent();
					result = OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, Yellow);			//    
					while(!result && TimeCurrent() - begin <= 30 && !IsTesting())
					{
						Sleep(100);
						result = OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, Yellow);			//    
					}
					if(!result)
					{
						int error = GetLastError();
						Print("   BUY #" + OrderTicket() + " " + ErrorDescription(error));
					}
				}
			}
			else
			{
				Print("    :" + ErrorDescription(error));
			}
		}
	}
}

void CheckForSL()
{
	int i;
	int Orders = OrdersTotal();
	datetime begin;
	int error;
	bool result;
	
	for(i = Orders-1; i >= 0; i--)
	{
		if(!OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
		{
			Print("    :" + ErrorDescription(error));
			continue;
		}

		if(OrderSymbol() == Symbol() && OrderType() == OP_BUY && OrderMagicNumber() == BuyMagic && 
			NormalizeDouble(Bid, Digits) <= NormalizeDouble(OrderOpenPrice() - StopLoss*Point, Digits))
		{
			begin = TimeCurrent();
			result = OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, Yellow);			//    
			while(!result && TimeCurrent() - begin <= 30 && !IsTesting())
			{
				Sleep(100);
				result = OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, Yellow);			//    
			}
			if(!result)
			{
				error = GetLastError();
				Print("   BUY #" + OrderTicket() + " " + ErrorDescription(error));
			}
		}
		else if(OrderSymbol() == Symbol() && OrderType() == OP_SELL && OrderMagicNumber() == SellMagic &&
					NormalizeDouble(Ask, Digits) >= NormalizeDouble(OrderOpenPrice() + StopLoss*Point, Digits))
		{
			begin = TimeCurrent();
			result = OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, Yellow);			//    
			while(!result && TimeCurrent() - begin <= 30 && !IsTesting())
			{
				Sleep(100);
				result = OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, Yellow);			//    
			}
			if(!result)
			{
				error = GetLastError();
				Print("   SELL #" + OrderTicket() + " " + ErrorDescription(error));
			}
		}
	}
}